import './GameAction.css';
import React from 'react';
import { useLocation, matchPath } from "react-router";

import Create from './GameAction/Create';

import Reject from './GameAction/Reject';
import Cancel from './GameAction/Cancel';
import Accept from './GameAction/Accept';

import DrawReq from './GameAction/DrawReq';
import DrawAcq from './GameAction/DrawAcq';
import Surrender from './GameAction/Surrender';

import Backward from './GameAction/Backward';
import Forward from './GameAction/Forward';

// import { AppContext } from '../../context/app'

export default function GameAction() {
  // const [ctx, dispatchCtx] = React.useContext(AppContext)

  const { pathname } = useLocation();
  const isNewGamePath = matchPath("/game/new", pathname);
  const isProposalPath = matchPath("/game/proposal/*", pathname);
  const isActivelPath = matchPath("/game/active/*", pathname);
  const isArchivePath = matchPath("/game/archive/*", pathname);

  return (
    <div className='action-panel'>
      {isNewGamePath && <Create />}

      {isProposalPath && <Reject />}
      {isProposalPath && <Cancel />}
      {isProposalPath && <Accept />}

      {isActivelPath && <DrawReq />}      
      {isActivelPath && <DrawAcq />}      
      {isActivelPath && <Surrender />}

      {isArchivePath && <Backward />}      
      {isArchivePath && <Forward />}      
    </div>
  )
}